- NAME
- SYNOPSIS
- DESCRIPTION
- RETURN VALUES
- WARNING
- SEE ALSO
- HISTORY
- COPYRIGHT

# NAME

BN_mod_mul_montgomery, BN_MONT_CTX_new, BN_MONT_CTX_free, BN_MONT_CTX_set, BN_MONT_CTX_copy, BN_from_montgomery, BN_to_montgomery - Montgomery multiplication

# SYNOPSIS

     #include <openssl/bn.h>

     BN_MONT_CTX *BN_MONT_CTX_new(void);
     void BN_MONT_CTX_free(BN_MONT_CTX *mont);

     int BN_MONT_CTX_set(BN_MONT_CTX *mont, const BIGNUM *m, BN_CTX *ctx);
     BN_MONT_CTX *BN_MONT_CTX_copy(BN_MONT_CTX *to, BN_MONT_CTX *from);

     int BN_mod_mul_montgomery(BIGNUM *r, BIGNUM *a, BIGNUM *b,
             BN_MONT_CTX *mont, BN_CTX *ctx);

     int BN_from_montgomery(BIGNUM *r, BIGNUM *a, BN_MONT_CTX *mont,
             BN_CTX *ctx);

     int BN_to_montgomery(BIGNUM *r, BIGNUM *a, BN_MONT_CTX *mont,
             BN_CTX *ctx);

# DESCRIPTION

These functions implement Montgomery multiplication. They are used automatically when RETURN VALUES

BN_MONT_CTX_new() returns the newly allocated BN_MONT_CTX, and NULL on error.

BN_MONT_CTX_free() has no return value.

For the other functions, 1 is returned for success, 0 on error. The error codes can be obtained by WARNING

The inputs must be reduced modulo m, otherwise the result will be outside the expected range.

# SEE ALSO

BN_add(3), HISTORY

BN_MONT_CTX_init() was removed in OpenSSL 1.1.0

# COPYRIGHT

Copyright 2000-2017 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the OpenSSL license (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at https://www.openssl.org/source/license.html.